package org.opengroup.osdu.notification.util;

import com.google.common.base.Strings;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class GCPTestUtils extends TestUtils {

    public GCPTestUtils() {

    }

    @Override
    public synchronized String getOpsToken() throws Exception {
        if(Strings.isNullOrEmpty(opsToken)) {
            opsToken = getToken("DE_OPS_TESTER");
        }
        return opsToken;
    }

    @Override
    public synchronized String getAdminToken() throws Exception {
        if(Strings.isNullOrEmpty(adminToken)) {
            adminToken = getToken("DE_ADMIN_TESTER");
        }
        return adminToken;
    }

    @Override
    public synchronized String getEditorToken() throws Exception {
        if(Strings.isNullOrEmpty(editorToken)) {
            editorToken = getToken("DE_EDITOR_TESTER");
        }
        return editorToken;
    }

    @Override
    public synchronized String getNoAccessToken() throws Exception {
        if(Strings.isNullOrEmpty(noAccessToken)) {
            noAccessToken = getToken("DE_NO_ACCESS_TESTER");
        }
        return noAccessToken;
    }

    private String getToken(String testerEnvVar) throws Exception {
        log.info("Get {} credentials", testerEnvVar);
        String serviceAccountValue = System.getProperty(testerEnvVar, System.getenv(testerEnvVar));
        String audience = System.getProperty("INTEGRATION_TEST_AUDIENCE", System.getenv("INTEGRATION_TEST_AUDIENCE"));
        if (Strings.isNullOrEmpty(audience)) {
            audience = "245464679631-ktfdfpl147m1mjpbutl00b3cmffissgq.apps.googleusercontent.com";
        }
        String token = new GoogleServiceAccount(serviceAccountValue).getAuthToken(audience);
        return "Bearer " + token;
    }
}
